<form [formGroup]="profileForm" (ngSubmit)="onSubmit()">
    <label>
        First Name:
        <input type="text" id="name" name="name" class="form-control" formControlName="firstName" required>
        <div *ngIf="f.firstName.invalid && (f.firstName.dirty || f.firstName.touched)" class="alert alert-danger">
            <div *ngIf="f.firstName.errors.required">Name is required</div>
            <div *ngIf="f.firstName.errors.minlength">
                Name must be at least 4 characters long.
            </div>
        </div>
    </label>

    <label>
        Last Name:
        <input type="text" formControlName="lastName">
    </label>

    <div formGroupName="address">
        <h3>Address</h3>

        <label>
            Street:
            <input type="text" formControlName="street">
        </label>

        <label>
            City:
            <input type="text" formControlName="city">
        </label>

        <label>
            State:
            <input type="text" formControlName="state">
        </label>

        <label>
            Zip Code:
            <input type="text" formControlName="zip">
        </label>
    </div>

    <div formArrayName="aliases">
        <h3>Aliases</h3><button (click)="addAliases()">Add Aliases</button>
        <div *ngFor="let alias of aliases.controls; let i=index">
            <label>
                Alias:
                <input type="text" [formControlName]="i">
            </label>
        </div>
    </div>

    <button type="submit" [disabled]="!profileForm.valid">Submit</button>
</form>

<p>
    Form Value: {{ profileForm.value | json }}
</p>

<p>
    Form Status: {{ profileForm.status }}
</p>

<p>
    <button (click)="updateProfile()">Update Profile</button>
</p>